/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author kirsch
 */
public class PostIt implements Serializable {
    String message;

    public PostIt(String message) {
        this.message = message;
    }

    public PostIt() {
        this.message = " ";
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    @Override
    public String toString () {
        return this.getMessage();
    }
    public void serialize () {
        try {
            ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream("postIt.dat"));
            out.writeObject(this);
        } catch (IOException ex) {
            Logger.getLogger(PostIt.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static PostIt deserialize() {
        PostIt post = null;
        try {
            ObjectInputStream in = new ObjectInputStream(new FileInputStream("postIt.dat"));
            post = (PostIt) in.readObject();
        } catch (IOException ex) {
            Logger.getLogger(PostIt.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(PostIt.class.getName()).log(Level.SEVERE, null, ex);
        }
        return post;
    }

    public static void main(String[] args) {
        PostIt post = new PostIt("This is a message in a bottle");
        post.serialize();
        PostIt post2 = PostIt.deserialize();
        System.out.println(post2);
    }

}
