/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review.exercices;

import java.util.Calendar;
import java.util.Date;
import java.util.Scanner;
import review.business.Employee;

/**
 *
 * @author kirsch
 */
public class PileEmploye {

    protected void readEmployee (Employee e) {
        Scanner in = new Scanner(System.in);
        System.out.print ("Name: ");
        if (in.hasNextLine()) e.setName(in.next());
        System.out.print("Salary: ");
        if (in.hasNextFloat()) e.setSalary(in.nextFloat());
        e.setHireDay(readDate(in));
    }

    protected Date readDate(Scanner in) {
        int day, month, year;

        System.out.print("Hire year: ");
        year = in.nextInt();
        System.out.print("Hire month (1-12): ");
        month = in.nextInt();
        System.out.print("Hire day: ");
        day = in.nextInt();

        Calendar cal = Calendar.getInstance();
        cal.set(year, (month-1), day);

        return cal.getTime();
    }

    protected void printEmployee (Employee e) {
        System.out.println("Name: " + e.getName());
        System.out.println("Salary: " + e.getSalary());
        System.out.println("Hire date: " + e.getHireDay());
    }


    Pile<Employee> pileEmp;

    public PileEmploye() {
        this.pileEmp = new MaPile<Employee>();
    }

    /** creer un nouveau employee et l'ajouter a la pile */
    public void newEmployee () {
        Employee e = new Employee();
        readEmployee(e);
        this.pileEmp.push(e);
    }

    /** on depile les employes de la pile */
    public void popEmployees () {
        while (!this.pileEmp.isEmpty()) {
            Employee e = this.pileEmp.pop();
            this.printEmployee(e);
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        PileEmploye test = new PileEmploye();
        test.newEmployee();
        test.newEmployee();
        test.popEmployees();
    }

}
