/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */
package review.exercices.business;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Calendar;

/**
 *
 * @author kirsch
 */
public class FormEmployee extends DepartmentView {

    private TextField nameText;
    private TextField salaryText;
    private TextField dayText;
    private TextField monthText;
    private TextField yearText;
    private Label status;
    private Button okBtn;

    private int changesCount;

    public FormEmployee(DepartmentControler control) {
        super(control);
        initComponents();
        changesCount=0;
    }

    private void initComponents() {
        nameText = new TextField();
        nameText.setColumns(35);
        salaryText = new TextField();
        salaryText.setColumns(15);
        dayText = new TextField();
        dayText.setColumns(2);
        monthText = new TextField();
        monthText.setColumns(2);
        yearText = new TextField();
        yearText.setColumns(4);
        status = new Label("Welcome!");

        okBtn = new Button();
        okBtn.setLabel("Add Employee");
        okBtn.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                handleButtonClick();
            }
        });


        Panel pcentre = new Panel();
        pcentre.setLayout(new GridLayout(5,2));
        pcentre.add(new Label("Name: "));
        pcentre.add(this.nameText);
        pcentre.add(new Label("Salary: "));
        pcentre.add(this.salaryText);
        pcentre.add(new Label("Hire day: "));
        pcentre.add(this.dayText);
        pcentre.add(new Label("Hire month: "));
        pcentre.add(this.monthText);
        pcentre.add(new Label("Hire year: "));
        pcentre.add(this.yearText);
        
        this.add(pcentre, BorderLayout.CENTER);
        this.add(okBtn, BorderLayout.EAST);
        this.add(status, BorderLayout.SOUTH);

        pack();
    }

    private void handleButtonClick() {
        Calendar cal = Calendar.getInstance();
        try {
           cal.set(Integer.parseInt(this.yearText.getText()),
                   Integer.parseInt(this.monthText.getText()),
                   Integer.parseInt(this.dayText.getText()));
           float sal = Float.parseFloat(this.salaryText.getText());

           this.getControler().notifyAddEmployee(this.nameText.getText(),
                   sal, cal.getTime());

        } catch (NumberFormatException nfe) {
            this.status.setText("Invalid salary or hire date");
        }
    }

    public void departmentChanged(DepartmentChangedEvent evt) {
        //ce formulaire ne fait qu'entrer des nouveaux employees
        //il ne montre pas le dept
        //donc, on ne fait que mettre a jour le label de status
        this.changesCount++;
        status.setText(this.changesCount+" changes ");
    }
}
